﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Code_Prufera
{
    internal class Prufer
    {
        public async void Prufer_Code()
        {
            string path = "pruf.txt";
            string path_write = "code_pruf.txt";
            StreamReader sr = new StreamReader(path);
            List<string> lines = new List<string>(); //Лист для счета данных из файла
            List<int> list_numb = new List<int>(); //Основной лист, где хранятся вершины
            List<int> list_code_pruf = new List<int>(); //Лист, в котором записывается код Прюфера
            while(!sr.EndOfStream) //Цикл для ввода из файла в лист
            {
                lines.Add(sr.ReadLine().Trim());
            }
            foreach (string item in lines) //Цикл для разбиения чисел из строки в число (было: "1 2", стало: 1,2)
            {
                string[] parts = item.Split(" ");
                foreach (string part in parts)
                {
                    if (int.TryParse(part, out int number))
                    {
                        list_numb.Add(number);
                    }
                }
            }
            for (int i = 0; i < list_numb.Count; i++) //Вывод матрицы данных
            {
                i++;
                Console.WriteLine(list_numb[i - 1] + "->" + list_numb[i]);
            }
            Console.WriteLine();
            int count = list_numb.Count - 1;
            while (count>1) //Цикл для повторения алгоритма
            {
                List<int> list_uniqueEl = FindUniqNumb(list_numb); //Лист с висячими вершинами
                int index_remove = list_numb.IndexOf(list_uniqueEl.Min());
                if (index_remove == 0 && list_numb.Count>2)
                {
                    list_code_pruf.Add(list_numb[index_remove + 1]);
                    list_numb.RemoveAt(index_remove);
                    list_numb.RemoveAt(index_remove + 1);
                }
                else if(list_numb.Count > 2)
                {
                    list_code_pruf.Add(list_numb[index_remove - 1]);
                    list_numb.RemoveAt(index_remove);
                    list_numb.RemoveAt(index_remove - 1);
                }
                count--;
            }
            using (StreamWriter wr = new StreamWriter(path_write)) //Запись в файл
            {
                foreach (int item in list_code_pruf)
                {
                    wr.Write(item);
                }
            }
            for (int i = 0; i < list_code_pruf.Count; i++) //Вывод кода Прюфера
            {
                Console.Write(list_code_pruf[i]);
            }
            Console.WriteLine();
        }
        public List<int> FindUniqNumb(List<int> list) //Метод, который позволяет узнать, какие есть уникальные значения в листе
        {
            Dictionary<int,int> dict_counts = new Dictionary<int, int>();
            foreach (int i in list) //Подсчет кол-во вхождений каждого элемента
            {
                if (dict_counts.ContainsKey(i))
                    dict_counts[i]++;
                else dict_counts[i] = 1;
            }
            List<int> list_uniqueEl = new List<int>();
            foreach (var pair in dict_counts) //Нахождение элементов, которые встр 1 раз
            {
                if(pair.Value == 1) list_uniqueEl.Add(pair.Key);
            }
            return list_uniqueEl;
        }
    }
}
